<?php
ini_set('display_errors', 'Off');

class YaTurbo
{
    public $isShowMessage = true;

    public $result;
    private $dataInsideTheTag; // отображение контента внутри тега
    private $tagsInfo; // информация о тегах
    private $tagIndex; // индекс текущего тега
    private $isCloseTag; // проверка на закрывающий тэг
    private $hideBlock; // скрытие опредленого блока если 1

    private $slideTagIndex; // ограничение на отображение галереи
    private $galleryTagIndex; // хранит информацию о индексе тега, что бы контент после галереи мог отображаться
    private $cardFourIndex; // хранит информацию о индексе каталога с продукцией

    private $imgCollectionCount; // текущее количество картинок
    private $cardCount; // текущее количество Карточек с продукцией/ наши работы
    private $imageCount;

    private $isCloseTagA;// проверка закрыт ли тег a
    private $isCloseTagTd; // проверка закрыт ли тег td
    private $tagACount; // если несколько тегов a подряд то выполнялется перенос строки для каждого элемента
    private $inputTagTrigger; // проверка что бы не заходил в элемены внутри тега

    private $isNotFindTag; // найден тег или нет

    /**
     * @var $MAX_IMAGE
     * Лимит на количество картинок.
     * Для загрузки через api лимит составляет 30 штук.
     * Для файловой загрузки в Вэбмастер 50.
     */
    public const MAX_IMAGE = 50;

    public const MESSAGE = '
    <p>Страница сгенерирована с помощью <a href="https://www.islandgift.ru/dev/generaterss">сервиса Maximko</a></p><p>Контактные данные<br>Сайт:<a href="https://www.islandgift.ru">islandgift.ru</a></p>
    <div data-block="widget-feedback" data-stick="false">
        <div data-block="chat" data-type="vkontakte" data-url="https://vk.com/islandgift"></div>       
        <div data-block="chat" data-type="whatsapp" data-url="https://api.whatsapp.com/send?phone=79092813520"></div>
        <div data-block="chat" data-type="telegram" data-url="http://t.me/max36895"></div>
        <div data-block="chat" data-type="facebook" data-url="https://www.facebook.com/groups/islandgift"></div>
        <div data-block="chat" data-type="viber" data-url="viber://chat?number=79092813520"></div>
        <div data-block="chat" data-type="google" data-url="http://plus.google.com/communities/118237901655250343991"></div>
        <div data-block="chat" data-type="twitter" data-url="https://twitter.com/strelocmax36895"></div>  
      </div>
    ';

    private const MENU = "<menu><a href='MAXIMKO_URL_SITE_INDEX_PAGE'>Главная</a></menu>";
    private const TAGS = [
        0 => ['<a', '</a>', '<a ', '</a>'],
        1 => ['<p', '</p>', '<p>', '</p>'],
        2 => ['<div', '</div>', '', ''],
        3 => ['<script', '</script>', '<!-- ', ' -->'],
        4 => ['<h2', '</h2>', '<h2>', '</h2>'],
        5 => ['<h1', '</h1>', '<h1>', '</h1>'],
        6 => ['<h3', '</h3>', '<h3>', '</h3>'],
        7 => ['<h4', '</h4>', '<h4>', '</h4>'],
        8 => ['<ul', '</ul>', '<ul>', '</ul>'],
        9 => ['<li', '</li>', '<li>', '</li>'],
        10 => ['<img', '', '<img ', ''],
        11 => ['<ol', '</ol>', '<ol>', '</ol>'],
        12 => ['<strong', '</strong>', '<strong>', '</strong>'],
        13 => ['<button', '</button>', '', ''],
        14 => ['<b', '</b>', '<b>', '</b>'],
        15 => ['<u', '</u>', '<u>', '</u>'],
        16 => ['<br', '', '<br>', ''],
        17 => ['<i', '</i>', '<i>', '</i>'],
        18 => ['<span', '</span>', '<span>', '</span>'],

        19 => ['<head', '</head>', '', ''],
        20 => ['<body', '</body>', '<turbo:content><![CDATA[<header>' . self::MENU . '</header>', ''],
        21 => ['<header', '</header>', '', ''],
        22 => ['<noscript', '</noscript>', '', ''],
        23 => ['<main', '</main>', '', ''],
        24 => ['<footer', '</footer>', '', ''],

        25 => ['<meta', '', '', ''],
        26 => ['<title', '</title>', '', ''],
        27 => ['<link', '', '', ''],
        28 => ['<style', '</style>', '', ''],
        29 => ['<html', '</html>', '<item turbo="true">', ''],
        30 => ['<!doctype', '', '', ''],
        31 => ['<nav', '</nav>', '<p>', '</p>'],
        32 => ['<section', '</section>', '<p>', '</p>'],

        33 => ['<table', '</table>', '<table>', '</table>'],
        34 => ['<thead', '</thead>', '', ''],
        35 => ['<tr', '</tr>', '<tr>', '</tr>'],
        36 => ['<td', '</td>', '<td', '</td>'],
        37 => ['<tbody', '</tbody>', '', ''],
        38 => ['<sup', '</sup>', '<sup>', '</sup>'],
        39 => ['<sub', '</sub>', '<sub>', '</sub>'],
        40 => ['<br/', '', '<br>', ''],
        41 => ['<iframe', '</iframe>', '<iframe width="560" height="315"', 'frameborder="0" allowfullscreen> </iframe>'],
        42 => ['<!--', '', '<!-- ', ' -->'],
        43 => ['<!DOCTYPE', '', '', ''],
        44 => ['<dl', '</dl>', '<table>', '</table>'],
        45 => ['<dt', '</dt>', '<tr><td>', '</td>'],
        46 => ['<dd', '</dd>', '<td>', '</td></tr>'],
        47 => ['<object', '</object>', '<p>', '</p>'],
        48 => ['<svg', '</svg>', '', ''],
        49 => ['<g', '</g>', '', ''],
        50 => ['<path', '</path>', '', ''],
        51 => ['<th', '</th>', '<td>', '</td>'],
        52 => ['<textarea', '</textarea>', '', ''],
        53 => ['<input', '', '<!-- ', ' -->'],
        54 => ['<small', '</small>', '<small>', '</small>'],
        55 => ['<form', '</form>', '', ''],
        56 => ['<label', '</label>', '<label>', '</label>'],
        57 => ['<norb', '</norb>', '', ''],
        58 => ['<math', '</math>', '', ''],
        59 => ['<mrow', '</mrow>', '', ''],
        60 => ['<msub', '</msub>', '<sub>', '</sub>'],
        61 => ['<mi', '</mi>', '', ''],
        62 => ['<mn', '</mn>', '', ''],
        63 => ['<mo', '</mo>', '', ''],
        64 => ['<mfrac', '</mfrac>', '', ''],
        65 => ['<mstyle', '</mstyle>', '', ''],
        66 => ['<mtext', '</mtext>', '', ''],
        67 => ['<msubsup', '</msubsup>', '<sub><sub>', '</sub></sub>'],
        68 => ['<mtable', '</mtable>', '<table>', '</table>'],
        69 => ['<mtr', '</mtr>', '<tr>', '</tr>'],
        70 => ['<mtd', '</mtd>', '<td>', '</td>'],
        71 => ['<msup', '</msup>', '<sup>', '</sup>'],
        72 => ['<msqrt', '</msqrt>', '', ''],
        73 => ['<em', '</em>', '', ''],
        74 => ['<noindex', '</noindex>', '<noindex>', '</noindex>'],
        75 => ['<blockquote', '</blockquote>', '<blockquote>', '</blockquote>'],
        76 => ['<ins', '</ins>', '', ''],
        77 => ['<picture', '</picture>', '<p>', '</p>'],
        78 => ['<!doctype', '', '', ''],
        79 => ['<title', '</title>', '', ''],
        80 => ['<select', '</select>', '<select>', '</select>'],
        81 => ['<option', '</option>', '<option>', '</option>'],
        82 => ['<h5', '</h5>', '<h5>', '</h5>'],
        83 => ['<h6', '</h6>', '<h6>', '</h6>'],
        84 => ['<font', '</font>', '', ''],
        85 => ['<hr', '', '<hr>', ''],
        86 => ['<ellipse', '', '', ''],
        87 => ['<line', '', '', ''],
        88 => ['<polygon', '</polygon>', '', ''],
        89 => ['<article', '</article>', '', ''],
        90 => ['<use', '', '', ''],
        91 => ['<defs', '</defs>', '', ''],
        92 => ['<center', '</center>', '', ''],
        93 => ['<fieldset', '</fieldset>', '', ''],
        94 => ['<spec_mark ', '</spec_mark_>', '', ''],
        95 => ['<mark', '</mark>', '', ''],
        96 => ['<base', '', '', ''],
        97 => ['<address', '</address>', '<p>', '</p>'],
        98 => ['<aside', '</aside>', '<p>', '</p>'],

        99 => ['<video', '</video>', '<video>', '</video>'],
        100 => ['<menu', '</menu>', '<ul', '</ul>'],
        101 => ['<audio', '</audio>', '<audio', '</audio>'],
        102 => ['<canvas', '</canvas>', '', ''],
        103 => ['<details', '</details>', '<p>', '</p>'],
        104 => ['<keygen', '</keygen>', '', ''],
        105 => ['<time', '</time>', '<p>', '</p>'],
        106 => ['<figcaption', '</figcaption>', '<figcaption>', '</figcaption>'],
        107 => ['<figure', '</figure>', '<figure>', '</figure>'],
        108 => ['<nobr', '</nobr>', '<i>', '</i>'],
    ];

    public $title = 'undefined';
    public $desc = 'undefined';
    public $yandexMetrika = '001100';
    public $rss = '';
    public $category = 'Официальный сайт';
    public $url;

    public $link = '';
    public $html;
    public $status;

    public static function pageNotFound(): void
    {
        header('HTTP/1.0 404 Not Found');
        header('Status: 404 Not Found');
    }

    /**
     * Проверка текста на пустоту,
     * А также производится проверка и исправление не валидного текста
     * @return bool
     */
    public function isValidCharacters(): bool
    {
        if ($this->html == '' || !$this->html) {
            return false;
        }
        // Этот блок можно удалить. Он нужен чтобы проверить страницу на корректность.
        //==============================================================================================================
        $dop = '';
        if (strpos($this->html, '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">') === false) {
            $dop = '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">';
        }
        $dom = new DOMDocument();
        $dom->loadHTML($dop . $this->html);
        $this->html = $dom->saveHTML();
        //==============================================================================================================
        return true;
    }

    /**
     * Генерирует Яндекс-турбо
     * @param $triggerBody
     * @return string
     */
    public function yandexTurbo($triggerBody)
    {
        $this->status = 1;
        try {
            $this->result = '';
            if ($triggerBody) {
                $this->start($this->title, $this->desc, $this->yandexMetrika);
            }

            if (!$this->isValidCharacters()) {
                $this->result .= self::TAGS[20][2];
            } else {
                $this->generate($this->html, $this->link);
            }

            if ($triggerBody) {
                $this->end();
            } else {
                $this->result .= (($this->isShowMessage) ? self::MESSAGE : '') . ']]></turbo:content></item>';
            }

            $this->result = str_replace('MAXIMKO_URL_SITE_INDEX_PAGE', $this->url, $this->result);

            $this->result = $this->removeJunk();
        } catch (Exception $e) {
            $this->status = 0;
            $this->result = 'Ошибка при генерации Страницы! Просьба обратиться к разработчикам!';
            $file = fopen(__DIR__ . '/../../kernel/error/turbo.log', 'a');
            fwrite($file, date('d-m-Y H:i:s') . ' ' . $e->getMessage() . "\n Trace\n" . $e->getTrace());
            fclose($file);
        }
        return $this->result;
    }

    /**
     * Удаление всего лишнего
     * - двойной перенос строки
     * - пустые теги
     * - стили и классы у блоков
     * @param string $html
     * @return string
     */
    protected function removeJunk(string $html = ''): string
    {
        if ($html !== '') {
            $this->result = $html;
        }

        $deletedElements = [
            '<!-- -->',
            '<!--  -->',
            "\r",
            "\t",
            " \n"
        ];

        $this->result = str_replace($deletedElements, '', $this->result);

        while (strpos($this->result, "  ") !== false || strpos($this->result, "\n\n") !== false) {
            $this->result = str_replace(['  ', "\n\n"], [' ', "\n"], $this->result);
        }

        // удаляем все стили, классы и пустые теги если они вдруг остались
        $this->result = preg_replace('/(<[^>]+) style=".*?"/iu', '$1', $this->result);
        $this->result = preg_replace('/<([^<\/>]*)>([\s]*?|(?R))<\/\1>/iu', '', $this->result);
        $this->result = preg_replace('/<([^\/]{0,5})\/>/iu', '', $this->result);
        return preg_replace('/(<[^>]+) class=".*?"/iu', '$1', $this->result);
    }

    protected function findTitle(string $text): void
    {
        preg_match_all("/<title>([^$]+?)<\/title>/miu", $text, $title);
        $this->title = $title[1][0] ?? 'undefined';
    }

    protected function findDescription(string $text): void
    {
        preg_match_all("/<meta([^>]+?)name=\"description\"([^$]+?)content=\"([^$]+?)\"/miu", $text, $desc);
        $this->desc = $desc[3][0] ?? 'undefined';
    }

    /**
     * Генерирование заголовка страницы (прописывать только для главной страницы)
     * @param $title
     * @param $desc
     * @param $yandexMetrika
     * @return string
     */
    public function start($title = '', $desc = '', $yandexMetrika = '001100'): string
    {
        $this->title = $title;
        $this->desc = $desc;
        if ($this->title == '') {
            $this->findTitle($this->html);
        }
        if ($this->desc == '') {
            $this->findDescription($this->html);
        }
        $this->yandexMetrika = $yandexMetrika;

        $this->result = '<?xml version="1.0" encoding="utf-8"?>
            <!--	created with www.islandgift.ru	-->
            <rss xmlns:yandex="http://news.yandex.ru" xmlns:media="http://search.yahoo.com/mrss/"
                 xmlns:turbo="http://turbo.yandex.ru" version="2.0">
            
                <channel>
                <turbo:cms_plugin>MaxImco Genarator</turbo:cms_plugin>
                    <title>' . $this->title . '</title>
                    <link>' . $this->url . '</link>
                    <description>' . $this->desc . '</description>
                    <language>ru</language>
                    <author>' . $this->url . '</author>
                    <yandex:analytics type="Yandex" id="' . $this->yandexMetrika . '"/>';
        return $this->result;
    }

    /**
     * Закрывающие теги для Яндекст-турбо
     * @param $isShowEnd
     * @return string
     */
    public function end($isShowEnd = true): string
    {
        if ($isShowEnd) {
            $this->result .= (($this->isShowMessage) ? self::MESSAGE : '') . ']]></turbo:content></item>';
        }
        $this->result .= '</channel></rss>';
        return $this->result;
    }

    private function initParam(): void
    {
        $this->isNotFindTag = false;
        $this->dataInsideTheTag = true;
        $this->tagsInfo = [-1];
        $this->tagIndex = 0;
        $this->isCloseTag = 1;
        $this->hideBlock = 0;
        $this->slideTagIndex = 0;
        $this->galleryTagIndex = 0;
        $this->cardFourIndex = 0;
        $this->imgCollectionCount = 0;
        $this->cardCount = 0;
        $this->isCloseTagA = false;
        $this->isCloseTagTd = false;
        $this->tagACount = -1;
        $this->inputTagTrigger = 1;
        $this->imageCount = 0;
    }

    /**
     * Генерация Турбо-страницы
     * @param $text
     * @param string $link
     * @return string
     */
    public function generate($text, $link = 'https://www.islandgift.ru'): string
    {
        $this->initParam();
        $text = str_replace("'", '"', $text);

        for ($i = 0; $i < strlen($text); $i++) {
            $openTag = $this->processOpenTag($text, $i);
            $i = $openTag[0];

            if ($openTag[1] == true) {
                break;
            }

            if ($this->processCloseTag($text, $i)) {
                continue;
            }

            if ($text[$i] == '<' && $text[$i + 1] == '/' && (mb_ereg('^[a-zA-Z!]', $text[$i + 2]))) {

                if ($this->inputTagTrigger == 1) {
                    $this->inputTagTrigger = 0;
                    $this->dataInsideTheTag = false;

                    if ($this->slideTagIndex == $this->tagIndex) {
                        $this->hideBlock = 0;
                    }

                    if ($this->galleryTagIndex == $this->tagIndex) {
                        $this->galleryTagIndex = 0;
                        $this->imgCollectionCount = 0;
                        $this->hideBlock = 0;
                    }

                    if ($this->cardFourIndex == $this->tagIndex) {
                        $this->cardFourIndex = 0;
                        $this->cardCount = 0;
                        $this->hideBlock = 0;
                    }

                    //if ($this->tagsInfo[$this->tagIndex] == 21) {
                    //     $this->hideBlock = 0;
                    //}

                    if ($this->tagsInfo[$this->tagIndex] == -1 || $this->isNotFindTag) {
                        $this->dataInsideTheTag = true;
                        $this->result .= $text[$i];
                        $isCloseTag = false;
                        $isTag = $this->tagsInfo[$this->tagIndex];

                        if ($isTag != -1) {
                            for ($it = 0; $it < mb_strlen(self::TAGS[$isTag][1]); $it++) {
                                if (self::TAGS[$isTag][1][$it] == mb_strtolower($text[$i + $it])) {
                                    $isCloseTag = true;
                                } else {
                                    $isCloseTag = false;
                                    break;
                                }
                            }
                        } else {
                            $isCloseTag = false;
                        }

                        $this->isNotFindTag = false;

                        if ($isCloseTag && $this->tagIndex > 0) {
                            $this->tagIndex--;
                        }
                        continue;
                    } else {
                        $isTag = $this->tagsInfo[$this->tagIndex];
                        $isCloseTag = false;

                        if ($isTag != -1) {
                            for ($it = 0; $it < mb_strlen(self::TAGS[$isTag][1]); $it++) {
                                if (self::TAGS[$isTag][1][$it] == mb_strtolower($text[$i + $it])) {
                                    $isCloseTag = true;
                                } else {
                                    $isCloseTag = false;
                                    break;
                                }
                            }
                        } else {
                            $isCloseTag = true;
                        }

                        if ($isCloseTag) {
                            if ($this->tagIndex > 0) {
                                $this->tagIndex--;
                            }

                            $this->result .= $this->hideBlock ? '' : self::TAGS[$isTag][3];

                            if ($this->tagACount > 0) {
                                $this->tagACount--;
                            }

                            if ($isTag == 20) {
                                break;
                            }
                        }
                    }
                } else {
                    $this->inputTagTrigger = 3;
                    $isCloseTag = false;
                    $isTag = $this->tagsInfo[$this->tagIndex];

                    if ($isTag != -1) {
                        for ($it = 0; $it < mb_strlen(self::TAGS[$isTag][1]); $it++) {
                            if (self::TAGS[$isTag][1][$it] == mb_strtolower($text[$i + $it])) {
                                $isCloseTag = true;
                            } else {
                                $isCloseTag = false;
                                break;
                            }
                        }
                    } else {
                        $isCloseTag = true;
                    }

                    if ($isCloseTag) {
                        if ($this->tagIndex > 0) {
                            $this->tagIndex--;
                        }
                    }
                }
            }

            if ($this->tagsInfo[$this->tagIndex] == -2) {
                $this->tagIndex--;
            }

            $updateI = $this->processTable($text, $i);

            if ($i != $updateI) {
                $i = $updateI;
                continue;
            }

            $updateI = $this->processVideo($text, $i);
            if ($i != $updateI) {
                $i = $updateI;
                continue;
            }

            $updateI = $this->processImg($text, $i);
            if ($i != $updateI) {
                $i = $updateI;
                continue;
            }

            $updateI = $this->processLink($text, $i);
            if ($i != $updateI) {
                $i = $updateI;
                continue;
            }

            $updateI = $this->processTitle($text, $i, $link);
            if ($i != $updateI) {
                $i = $updateI;
            }
            $updateI = $this->processDesc($text, $i);
            if ($i != $updateI) {
                $i = $updateI;
                continue;
            }
            if ($this->dataInsideTheTag) {
                // if ($this->tagsInfo[$this->tagIndex] == 17) {
                //     $this->result .= str_replace('?', '', $text[$i]);
                // } else {
                $this->result .= $text[$i];
                // }
            }
        }
        return $this->result;
    }

    /**
     * поиск и генерация таблиц
     * @param $text
     * @param $i
     * @return int
     */
    private function processTable($text, $i): int
    {
        if ($this->dataInsideTheTag == false && $this->tagsInfo[$this->tagIndex] == 36) {
            if (!$this->hideBlock) {
                while ($text[$i] != '>') {
                    $input = $i + 8;
                    if (($text[$i] == 'r' && $text[$i + 1] == 'o' && $text[$i + 2] == 'w') || ($text[$i] == 'c' && $text[$i + 1] == 'o' && $text[$i + 2] == 'l')) {
                        $this->result .= ' ';
                        while ($text[$i] != '"' || $i == $input) {
                            $this->result .= $text[$i];
                            $i++;
                        }
                        $this->result .= $this->hideBlock ? '' : '"';
                        $this->isCloseTagTd = false;
                    } else {
                        $i++;
                    }
                }
                $i--;
            }
        }
        return $i;
    }

    /**
     * Поиск и генерация видео
     * @param $text
     * @param $i
     * @return int
     */
    private function processVideo($text, $i): int
    {
        if ($this->dataInsideTheTag == false && $this->tagsInfo[$this->tagIndex] == 41) {
            if (!$this->hideBlock) {
                while ($text[$i] != '>') {
                    $input = $i + 4;
                    if ($text[$i] == 's' && $text[$i + 1] == 'r' && $text[$i + 2] == 'c') {
                        while ($text[$i] != '"' || $i == $input) {
                            $this->result .= $text[$i];
                            if ($i == $input) {
                                if (($text[$i] != '/' && $text[$i + 1] != '/') || ($text[$i + 1] != '/' && $text[$i + 2] != '/') || ($text[$i + 2] != '/' && $text[$i + 3] != '/')) {
                                    $this->result .= 'https://www.youtube.com/embed/';
                                }
                            }
                            $i++;
                        }
                        $this->result .= '?rel=0&amp;showinfo=0" ';
                    } else {
                        $i++;
                    }
                }
                $i--;
            }
        }
        return $i;
    }

    /**
     * Поиск и обработка картинок
     *
     * Также осуществляем проверку на то, что не превышен лимит по загрузке картинок
     * Если лимит достигнут, тогда картинки не отображаются.
     *
     * @param $text
     * @param $i
     * @return int
     */
    private function processImg($text, $i): int
    {
        $isImage = true;
        $isImageSrc = false;
        if (($this->dataInsideTheTag == false) && ($this->tagsInfo[$this->tagIndex] == 10)) {
            if (!$this->hideBlock) {
                if ($this->imageCount < self::MAX_IMAGE) {
                    while ($text[$i] != '>') {
                        $input = $i + 4;
                        if ($text[$i] == 's' && $text[$i + 1] == 'r' && $text[$i + 2] == 'c' && ($text[$i + 3] == '=' || $text[$i + 3] == ' ')) {
                            $imageDir = '';
                            while ($text[$i] != '"' || $i <= $input) {
                                $imageDir .= $text[$i];
                                if ($text[$i] == '"') {
                                    if ($text[$i + 1] == 'h' && $text[$i + 2] == 't' && $text[$i + 3] == 't' && $text[$i + 4] == 'p'
                                        && ($text[$i + 5] == 's' || $text[$i + 5] == ':') && ($text[$i + 6] == ':' || $text[$i + 6] == '/')) {
                                    } else {
                                        $imageDir .= $this->url . (($text[$i + 1] == '/') ? '' : '/');
                                    }
                                }
                                $i++;
                            }
                            if (strpos(mb_strtolower($imageDir), '.jpg') === false && strpos(mb_strtolower($imageDir), '.png') === false) {
                                $imageDir = '"';
                                $isImage = false;
                            } else {
                                $this->imageCount++;
                            }
                            $this->result .= $imageDir . '" >';
                            if ($this->galleryTagIndex != 0) {
                                if ($this->imgCollectionCount < 6) {
                                    $this->imgCollectionCount++;

                                } else {
                                    //$this->result .= '>';
                                    $this->hideBlock = 1;
                                }
                            }
                            $isImageSrc = true;
                        } else {
                            $i++;
                            continue;
                        }
                    }
                    $i--;
                    if (!$isImage) {
                        $this->result = substr($this->result, 0, -10);
                    }
                    if (!$isImageSrc) {
                        $this->result = substr($this->result, 0, -6);
                    }
                } else {
                    while ($text[$i] != '>') {
                        $i++;
                    }
                    $i--;
                    $this->result = substr($this->result, 0, -5);
                }
            }
        }

        return $i;
    }

    /**
     * Поиск и создание ссылок
     * @param $text
     * @param $i
     * @return int
     */
    private function processLink($text, $i): int
    {
        if ($this->dataInsideTheTag == false && $this->tagsInfo[$this->tagIndex] == 0) {
            if (!$this->hideBlock) {
                while ($text[$i] != '>') {
                    $input = $i + 5;
                    if ($text[$i] == 'h' && $text[$i + 1] == 'r' && $text[$i + 2] == 'e' && $text[$i + 3] == 'f' && ($text[$i + 4] == '=' || $text[$i + 4] == ' ')) {
                        while ($text[$i] != '"' || $i == $input) {
                            $this->result .= $text[$i];
                            if ($text[$i] == '"') {
                                if (($text[$i + 1] == 'h' && $text[$i + 2] == 't' && $text[$i + 3] == 't' && $text[$i + 4] == 'p') || ($text[$i + 1] == '/' && $text[$i + 2] == '/')) {

                                } else {
                                    $this->result .= $this->url;
                                    if ($text[$i + 1] !== '/') {
                                        $this->result .= '/';
                                    }
                                }
                            }
                            $i++;
                        }
                        $this->result .= '">';
                        $this->isCloseTagA = true;
                    } else {
                        $i++;
                        continue;
                    }
                }
                $i--;
            }
        }
        return $i;
    }

    /**
     * Поиск заголовка и страницы
     * @param $text
     * @param $i
     * @param $link
     * @return int
     */
    private function processTitle($text, $i, $link): int
    {
        if (($this->dataInsideTheTag == false) && ($this->tagsInfo[$this->tagIndex] == 26)) {
            while ($text[$i] != '>') {
                $i++;
            }
            $i++;
            $this->result .= '<title>';
            while ($text[$i] != '<') {
                $this->result .= $text[$i];
                $i++;
            }
            $this->result .= '</title>';
            $this->result .= '<link>' . $link . '</link><category>' . $this->category . '</category>';
            while ($text[$i] != '>') {
                $i++;
            }
            $i--;
            if ($this->tagIndex > 0) {
                $this->tagIndex--;
            }
        }
        return $i;
    }

    /**
     * Поиск описания страницы
     * @param $text
     * @param $i
     * @return int
     */
    private function processDesc($text, $i): int
    {
        $isDescription = false;
        if ($this->dataInsideTheTag == false && $this->tagsInfo[$this->tagIndex] == 25) {
            while ($text[$i] != '>') {
                $id = $i + 6;
                if ($text[$i] == 'n' && $text[$i + 1] == 'a' && $text[$i + 2] == 'm' && $text[$i + 3] == 'e') {
                    $desc = '';
                    while ($text[$id] != '"') {
                        $desc .= $text[$id];
                        $id++;
                    }
                    $i = $id - 1;
                    if ($desc == 'description') {
                        $isDescription = true;
                    }
                }
                if ($text[$i] == 'c' && $text[$i + 1] == 'o' && $text[$i + 2] == 'n' && $text[$i + 3] == 't' && $text[$i + 4] == 'e' && $text[$i + 5] == 'n' && $text[$i + 6] == 't') {
                    $description = '';
                    $id = $i + 9;
                    while ($text[$id] != '"') {
                        $description .= $text[$id];
                        $id++;
                    }
                    $i = $id - 1;

                    if ($isDescription) {
                        $this->result .= '<description>';
                        $this->result .= $description;
                        $this->result .= '</description>';
                    }
                }
                $i++;
            }
            $i--;
        }
        return $i;
    }

    /**
     * Обработка закрывающего тега
     * @param $text
     * @param $i
     * @return bool
     */
    private function processCloseTag($text, $i): bool
    {
        if ($text[$i] == '>') {
            if ($this->inputTagTrigger == 0) {
                $this->inputTagTrigger = 1;
            } elseif ($this->inputTagTrigger == 3) {
                if ($this->tagsInfo[$this->tagIndex] == -1) {
                    $this->inputTagTrigger = 1;
                } else {
                    $this->inputTagTrigger = 0;
                }
                if ($this->isCloseTag == 0 && $this->tagIndex > 0) {
                    $this->tagIndex--;
                }
                return true;
            } else {
                $this->isNotFindTag = false;
            }

            if ($this->dataInsideTheTag) {
                $this->result .= $this->hideBlock ? '' : $text[$i];
            }

            if ($this->isCloseTag == 0) {
                $this->result .= $this->hideBlock ? '' : self::TAGS[$this->tagsInfo[$this->tagIndex]][3] ?? '';

                if ($this->tagIndex > 0) {
                    $this->tagIndex--;
                }

                $this->dataInsideTheTag = $this->hideBlock ? false : true;
                $this->isCloseTag = 1;
            } else {
                if ($this->tagsInfo[$this->tagIndex] == 3 /*|| $this->tagsInfo[$this->tagIndex] == 22*/
                    || $this->tagsInfo[$this->tagIndex] == 24 || $this->tagsInfo[$this->tagIndex] == 28) {
                    $this->dataInsideTheTag = false;
                } elseif ($this->tagsInfo[$this->tagIndex] == 0) {
                    if (!$this->isCloseTagA) {
                        $this->result .= $this->hideBlock ? '' : '>';
                        $this->isCloseTagA = true;
                    }
                    $this->dataInsideTheTag = $this->hideBlock ? false : true;
                } elseif ($this->tagsInfo[$this->tagIndex] == 36) {
                    if (!$this->isCloseTagTd) {
                        $this->result .= $this->hideBlock ? '' : '>';
                        $this->isCloseTagTd = true;
                    }
                    $this->dataInsideTheTag = $this->hideBlock ? false : true;
                } elseif ($this->tagsInfo[$this->tagIndex] != -1) {
                    $this->dataInsideTheTag = $this->hideBlock ? false : true;
                } else {
                    //$this->result .= $this->hideBlock ? '' : $text[$i].'2';
                }
            }
            return true;
        }
        return false;
    }

    /**
     * Поиск тегов
     * @param $text
     * @param $i
     * @param $status
     * @return array
     */
    private function findTag($text, $i, $status): array
    {
        $isTag = -1;
        for ($j = 0; $j < count(self::TAGS); $j++) {
            $index = $i;
            $isTag = -1;

            if ($text[$i + 1] == ' ' || $text[$i + 1] == '>') {
                if ($isTag > 0) {
                    break;
                }
            }

            for ($k = 0; $k < mb_strlen(self::TAGS[$j][0]); $k++) {
                if (mb_strtolower($text[$index]) == self::TAGS[$j][0][$k]) {
                    $isTag = $j;
                } else {
                    $isTag = -1;
                    break;
                }
                $index++;
            }

            // Проверка на то что используются html комментарий
            if ($isTag != 42) {
                // обработка скриптов
                if ($isTag == 3) {
                    while (1) {
                        if ($text[$i] == '<' && $text[$i + 1] == '/' && $text[$i + 2] == 's' && $text[$i + 3] == 'c' && $text[$i + 4] == 'r'
                            && $text[$i + 5] == 'i' && $text[$i + 6] == 'p' && $text[$i + 7] == 't' && $text[$i + 8] == '>') {
                            break;
                        }
                        $i++;
                    }
                    $i += 8;
                    return [$i, $status];
                }

                $divisions = [
                    '>',
                    ' ',
                    "\r",
                    "\t",
                    "\n",
                    '/',
                ];
                if ($isTag != -1) {
                    $isTagFind = false;
                    foreach ($divisions as $division) {
                        if ($text[$index] == $division) {
                            $isTagFind = true;
                            break;
                        }
                    }
                    if ($isTagFind) {
                        break;
                    }
                }
            } else {
                while (1) {
                    if ($text[$i] == '-' && $text[$i + 1] == '-' && $text[$i + 2] == '>') {
                        break;
                    }
                    $i++;
                }
                $i += 2;
                return [$i, $status];
            }
        }
        return ['isTag' => $isTag, 'index' => $i, 'status' => $status];
    }

    /**
     * Обработка открывающего тега и поиск его в массиве
     * @param $text
     * @param $i
     * @return array
     */
    private function processOpenTag($text, $i): array
    {
        $status = false;
        if ($text[$i] == '<' && $text[$i + 1] != '/' && (mb_ereg('^[a-zA-Z!]', $text[$i + 1]))) {
            if ($this->inputTagTrigger == 1) {
                $this->isNotFindTag = false;
                $this->inputTagTrigger = 0;

                //if ($this->tagsInfo[$this->tagIndex] == 21) {
                //    $this->hideBlock = 1;
                //}

                $this->dataInsideTheTag = false;

                $findTag = $this->findTag($text, $i, $status);
                if (!isset($findTag['isTag'])) {
                    return $findTag;
                } else {
                    $isTag = $findTag['isTag'];
                    $i = $findTag['index'];
                    $status = $findTag['status'];
                }

                if ($isTag != -1) {
                    $this->tagIndex++;
                    $this->tagsInfo[$this->tagIndex] = $isTag;

                    if ($this->tagsInfo[$this->tagIndex] == 0) {
                        $this->isCloseTagA = false;
                        if ($this->tagACount >= 0) {
                            $this->tagACount++;
                        } else {
                            $this->tagACount++;
                        }
                    } else {
                        $this->tagACount = -1;
                    }

                    if ($this->tagsInfo[$this->tagIndex] == 36) {
                        $this->isCloseTagTd = false;
                    }
                    $this->result .= $this->hideBlock ? '' : self::TAGS[$isTag][2];

                    if (self::TAGS[$isTag][1] == '' || self::TAGS[$isTag][1] == ' ') {
                        $this->isCloseTag = 0;
                    } else {
                        $this->isCloseTag = 1;
                    }

                } else {
                    $this->dataInsideTheTag = $this->hideBlock ? false : true;
                    $this->inputTagTrigger = 1;
                    $this->isNotFindTag = true;
                    //$this->tagIndex++;
                    //$this->tagsInfo[$this->tagIndex] = $isTag;
                }
                // обработка галереи и списка оборудования, что бы отображалось не больше определенноего количества
                $i = $this->processGallery($text, $i);
            } else {
                $isTag = -1;
                for ($j = 0; $j < count(self::TAGS); $j++) {
                    $index = $i;
                    $isTag = -1;

                    if ($text[$i + 1] == ' ' || $text[$i + 1] == '>') {
                        if ($isTag > 0) {
                            break;
                        }
                    }

                    for ($k = 0; $k < strlen(self::TAGS[$j][0]); $k++) {
                        if (mb_strtolower($text[$index]) == self::TAGS[$j][0][$k]) {
                            $isTag = $j;
                        } else {
                            $isTag = -1;
                            break;
                        }
                        $index++;
                    }
                }
                $this->tagIndex++;
                $this->tagsInfo[$this->tagIndex] = $isTag;
                $this->inputTagTrigger = 3;
            }
        }
        return [$i, $status];
    }

    // поиск галлереи картинов
    private function processGallery($text, $i): int
    {
        $tmpIndex = $i;
        $triggerGallery = false;
        if ($this->tagsInfo[$this->tagIndex] == 2) {
            $class = 'gallery-slider';
            $len = strlen($class);
            $index = 0;
            while ($text[$i] != '>') {
                for ($k = 0; $k < $len; $k++) {
                    if ($text[$i + $k] == $class[$k]) {
                        $index++;
                    } else {
                        $index = 0;
                    }
                }
                if ($index == $len) {
                    $this->slideTagIndex = $this->tagIndex;
                    $this->hideBlock = 1;
                } else {
                    $classTmp = '"photo-gallery"';
                    $indexTmp = 0;
                    for ($k = 0; $k < strlen($classTmp); $k++) {
                        if ($text[$i + $k] == $classTmp[$k]) {
                            $indexTmp++;
                        } else {
                            $indexTmp = 0;
                        }
                    }
                    $classCardTmp = 'card-slider';
                    if ($indexTmp == 0) {
                        for ($k = 0; $k < strlen($classCardTmp); $k++) {
                            if ($text[$i + $k] == $classCardTmp[$k]) {
                                $indexTmp++;
                            } else {
                                $indexTmp = 0;
                            }
                        }
                    }
                    $classCardSliderTmp = 'card-slide';
                    if ($indexTmp == 0) {
                        for ($k = 0; $k < strlen($classCardSliderTmp); $k++) {
                            if ($text[$i + $k] == $classCardSliderTmp[$k]) {
                                $indexTmp++;
                            } else {
                                $indexTmp = 0;
                            }
                        }
                    }
                    if ($indexTmp == strlen($classTmp)) {
                        $this->galleryTagIndex = $this->tagIndex;
                        $triggerGallery = true;
                    } elseif ($indexTmp == strlen($classCardTmp)) {
                        $this->cardFourIndex = $this->tagIndex;
                        $triggerGallery = true;
                    } elseif ($indexTmp == strlen($classCardSliderTmp)) {
                        if ($this->cardFourIndex != 0) {
                            if ($this->cardCount < 4) {
                                $this->cardCount++;
                            } else {
                                $this->hideBlock = 1;
                            }
                        }
                        $triggerGallery = true;
                    } else {
                        $triggerGallery = false;
                    }
                }
                $i++;
            }
            $i--;
        }

        if (!$triggerGallery) {
            $i = $tmpIndex;
        }

        return $i;
    }
}